#
# Conditional build:
%bcond_without	apidocs		# doxygen apidocs build
%bcond_without	static_libs	# static library
%bcond_without	tests		# tests during build

Summary:	API for manipulating JSON
Summary(pl.UTF-8):	API do operacji na strukturach JSON
Name:		jsoncpp
Version:	1.9.5
Release:	3
License:	MIT or Public Domain
Group:		Libraries
#Source0Download: https://github.com/open-source-parsers/jsoncpp/releases
Source0:	https://github.com/open-source-parsers/jsoncpp/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	d6c8c609f2162eff373db62b90a051c7
Patch0:		%{name}-cmake-prefer-shared.patch
URL:		https://github.com/open-source-parsers/jsoncpp/
BuildRequires:	cmake >= 3.8.0
BuildRequires:	libstdc++-devel >= 6:4.8.1
BuildRequires:	python3
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 1.605
%if %{with apidocs}
BuildRequires:	doxygen
BuildRequires:	graphviz
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
JSONCPP provides a simple API to manipulate JSON values, and handle
serialization and unserialization to strings.

%description -l pl.UTF-8
JSONCPP udostępnia proste API do operacji na wartościach JSON oraz
obsługi serializacji oraz deserializacji z łańcuchów znaków.

%package devel
Summary:	Header files for JSONCPP library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki JSONCPP
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for JSONCPP library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki JSONCPP.

%package static
Summary:	Static JSONCPP library
Summary(pl.UTF-8):	Statyczna biblioteka JSONCPP
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static JSONCPP library.

%description static -l pl.UTF-8
Statyczna biblioteka JSONCPP.

%package apidocs
Summary:	API documentation for JSONCPP library
Summary(pl.UTF-8):	Dokumentacja API biblioteki JSONCPP
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for JSONCPP library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki JSONCPP.

%prep
%setup -q
%patch0 -p1

%build
install -d build
cd build
%cmake .. \
	-DBUILD_OBJECT_LIBS=OFF \
	%{!?with_static_libs:-DBUILD_STATIC_LIBS=OFF} \
	-DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir}/%{name} \
	-DJSONCPP_WITH_CMAKE_PACKAGE=ON \
	%{!?with_tests:-DJSONCPP_WITH_TESTS=OFF} \
	-DSTATIC_SUFFIX=
cd ..
%{__make} -C build

%if %{with apidocs}
ln -sf build/version .
%{__python3} doxybuild.py \
	--dot=/usr/bin/dot \
	--doxygen=/usr/bin/doxygen
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS LICENSE README.md
%attr(755,root,root) %{_libdir}/libjsoncpp.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjsoncpp.so.25

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjsoncpp.so
%{_includedir}/jsoncpp
%{_pkgconfigdir}/jsoncpp.pc
%{_libdir}/cmake/jsoncpp

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libjsoncpp.a
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc dist/doxygen/jsoncpp-api-html-*/*
%endif
%changelog
* Wed May 10 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/jsoncpp.git;a=log;h=master

* Wed May 10 2023 Jakub Bogusz <qboosh@pld-linux.org> db70cfa
- added cmake-prefer-shared patch: let namespaced target (JsonCpp::JsonCpp) point to shared instead of static library
- fixed description
- release 3

* Thu Nov 03 2022 Jan Palus <atler@pld-linux.org> 991b93f
- Release 2 (by relup.sh)

* Thu Nov 03 2022 Jan Palus <atler@pld-linux.org> 1190b61
- add missing build step

* Thu Nov 03 2022 Jan Palus <atler@pld-linux.org> 758a48d
- fix build with apidocs

* Thu Nov 03 2022 Jan Palus <atler@pld-linux.org> 185794a
- rpm version for noarch subpackage

* Thu Nov 03 2022 Jan Palus <atler@pld-linux.org> d849e03
- macros for %cmake

* Thu Nov 03 2022 Jan Palus <atler@pld-linux.org> 8dd617d
- up to 1.9.5 (new soname)

* Tue Mar 01 2022 Marcin Krol <hawk@tld-linux.org> dac5b02
- switch to python3

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> e9ea84f
- unconditional noarch subpackages

* Thu Mar 01 2018 Jakub Bogusz <qboosh@pld-linux.org> 16cbca5
- updated to 1.8.4 (note: new soname)

* Sat Jan 21 2017 Jakub Bogusz <qboosh@pld-linux.org> 551d002
- updated to 1.8.0 (note: new soname)

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 582df21
- noarch apidoc

* Mon Sep 21 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> dc41cd8
- release 3 (by relup.sh)

* Mon May 04 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> f14332c
- rel 2; make it compatible with how other distros package it

* Mon May 04 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 6b377cf
- up to 1.6.2

* Sun Apr 05 2015 Jakub Bogusz <qboosh@pld-linux.org> 2bb6925
- package static library

* Tue Mar 10 2015 Jan Rękorajski <baggins@pld-linux.org> d5efa50
- up to 1.6.0
- removed obsolete patches

* Mon Mar 09 2015 Jan Rękorajski <baggins@pld-linux.org> 49e003d
- release 2 (by relup.sh)

* Fri Dec 26 2014 Jakub Bogusz <qboosh@pld-linux.org> 1fe9b66
- new URLs, updated to 1.0.0 (note: new soname, headers must be used as <jsoncpp/*> now)
- switch from scons to cmake build system, which is less broken
- removed obsolete optflags patch and .pc file
- added test patch (don't try to compare floats exactly)
- added libdir patch

* Sun Jun 15 2014 Jakub Bogusz <qboosh@pld-linux.org> 68cefea
- pl, cleanups, build doxygen apidocs

